import { unstate } from "svelte";
export function useService(machine, options) {
    const { actions, context, state: hydratedState } = options ?? {};
    const service = typeof machine === "function" ? machine() : machine;
    $effect(() => {
        service.setOptions({ actions: unstate(actions) });
    });
    $effect(() => {
        service.setContext(unstate(context));
        service._created();
    });
    $effect(() => {
        service.start(hydratedState);
        return service.stop;
    });
    return service;
}
